# -*- coding:utf-8 -*-
import datetime
import re

from NginxLog.DBDriver import DBDriver


def get_cell_data(row_data):
    re_result = re.match(
        r'^(?P<ip>\d+.\d+.\d+.\d+) - - \[(?P<time>.*) \+0000\] "(?P<url>.*)" (?P<status>\d{3}) .*',
        row_data)
    if re_result is None:
        print(row_data)
        return ["", "", "", ""]
    ip = re_result.group("ip")
    access_time = str(datetime.datetime.strptime(re_result.group("time"), '%d/%b/%Y:%H:%M:%S'))
    url = re_result.group("url")
    status = re_result.group("status")

    # cell_data = {"访问ip": ip, "访问时间": access_time, "访问地址": url, "访问状态": status}
    cell_data = [ip, access_time, url, status]
    # print(cell_data)
    return cell_data


if __name__ == '__main__':
    # 2021-04-27 11:22:05, 18:09:55
    date1 = datetime.datetime.strptime("2021-04-27 11:22:05", "%Y-%m-%d %H:%M:%S")
    date2 = datetime.datetime.strptime("2021-04-27 18:09:55", "%Y-%m-%d %H:%M:%S")
    print((date2 - date1).total_seconds())  # 24470
    exit(1)

    file_path = r"D:\Work\Git\deploy_script\NginxLog\access.log"
    db_driver = DBDriver("mysql+pymysql://jkq:741963@localhost:3306/test?charset=utf8")
    lines = 0
    insert_count = 0
    sql_str_list = []
    with open(file_path, 'r') as f:
        while lines < 2085100:
            data = f.readline()
            if data is None:
                print("exit:", lines)
                break
            cell_data = get_cell_data(data)
            # 拼接insert 字符串
            insert_sql_header = f"""insert into nginx_log
(ip,url,access_time,status)
values 
"""
            url = cell_data[2].replace("'", "''")
            sql_str_list.append(f"('{cell_data[0]}','{url}','{cell_data[1]}','{cell_data[3]}')")
            insert_count += 1
            # 100条执行一次
            if insert_count == 100:
                try:
                    # print(insert_sql_header + ",\n".join(sql_str_list))
                    db_driver.session.execute(insert_sql_header + ",\n".join(sql_str_list))
                    db_driver.session.commit()
                    sql_str_list = []
                    insert_count = 0
                except Exception as e:
                    print(e)
                    print(insert_sql_header + ",\n".join(sql_str_list))

            lines += 1
            print(lines)
