# -*- coding:utf-8 -*-
from sqlalchemy import create_engine
from sqlalchemy.orm import sessionmaker


class DBDriver:
    def __init__(self, connect_str: str):
        engine = create_engine(connect_str)
        self.DBSession = sessionmaker(bind=engine)
        self.new_session()

    def new_session(self):
        self.session = self.DBSession()
        return self.session

    def query_all(self, sql, **kwargs):
        if getattr(self, "session", None) is None or self.session.is_active is False:
            self.new_session()
        result = self.session.execute(sql, **kwargs).fetchall()
        return result

    def query_one(self, sql, **kwargs):
        if getattr(self, "session", None) is None or self.session.is_active is False:
            self.new_session()
        result = self.session.execute(sql, **kwargs).fetchone()
        return result

    def execute(self, sql, **kwargs):
        if getattr(self, "session", None) is None or self.session.is_active is False:
            self.new_session()
        self.session.execute(sql, **kwargs)
